SystemOrganization addCategory: #'EyeTracker-FFI'!
SystemOrganization addCategory: #'EyeTracker-Core'!
SystemOrganization addCategory: #'EyeTracker-Etoys'!

Player subclass: #EyePlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeTracker-Etoys'!

!EyePlayer methodsFor: 'positions' stamp: 'sgb 9/16/2015 16:00'!
getEyeNormalizedPositionX
^ self sendMessageToCostume: #eyeNormalizedPositionX! !

!EyePlayer methodsFor: 'positions' stamp: 'sgb 9/16/2015 16:00'!
getEyeNormalizedPositionY
^ self sendMessageToCostume: #eyeNormalizedPositionY! !

!EyePlayer methodsFor: 'positions' stamp: 'sgb 9/16/2015 15:59'!
getEyeNormalizedPositionZ
^ self sendMessageToCostume: #eyeNormalizedPositionZ! !

!EyePlayer methodsFor: 'positions' stamp: 'sgb 9/16/2015 15:59'!
getEyePositionX
^ self sendMessageToCostume: #eyePositionX! !

!EyePlayer methodsFor: 'positions' stamp: 'sgb 9/16/2015 15:59'!
getEyePositionY
^ self sendMessageToCostume: #eyePositionY! !

!EyePlayer methodsFor: 'positions' stamp: 'sgb 9/16/2015 15:59'!
getEyePositionZ
^ self sendMessageToCostume: #eyePositionZ! !

Player subclass: #EyeTrackerPlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeTracker-Etoys'!

!EyeTrackerPlayer methodsFor: 'connecting' stamp: 'sgb 9/1/2015 16:57'!
connect
	^ self sendMessageToCostume: #connect! !

!EyeTrackerPlayer methodsFor: 'connecting' stamp: 'sgb 9/1/2015 16:57'!
disconnect
	^ self sendMessageToCostume: #disconnect! !

!EyeTrackerPlayer methodsFor: 'connecting' stamp: 'sgb 9/1/2015 16:57'!
getConnectionState
	^ self sendMessageToCostume: #connectionState! !

!EyeTrackerPlayer methodsFor: 'screen and display' stamp: 'sgb 9/1/2015 16:57'!
getDisplaySizeHeight
	^ self sendMessageToCostume: #displaySizeHeight! !

!EyeTrackerPlayer methodsFor: 'screen and display' stamp: 'sgb 9/1/2015 16:58'!
getDisplaySizeWidth
	^ self sendMessageToCostume: #displaySizeWidth! !

!EyeTrackerPlayer methodsFor: 'connecting' stamp: 'sgb 9/1/2015 16:58'!
getIsConnected
	^ self sendMessageToCostume: #isConnected! !

!EyeTrackerPlayer methodsFor: 'screen and display' stamp: 'sgb 9/1/2015 16:58'!
getScreenBoundsHeight
	^ self sendMessageToCostume: #screenBoundsHeight! !

!EyeTrackerPlayer methodsFor: 'screen and display' stamp: 'sgb 9/1/2015 16:59'!
getScreenBoundsWidth
	^ self sendMessageToCostume: #screenBoundsWidth! !

Player subclass: #GazePlayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeTracker-Etoys'!

!GazePlayer class methodsFor: 'as yet unclassified' stamp: 'sgb 9/16/2015 16:13'!
getGazeX
	^ self sendMessageToCostume: #gazeX! !

!GazePlayer class methodsFor: 'as yet unclassified' stamp: 'sgb 9/16/2015 16:13'!
getGazeY
	^ self sendMessageToCostume: #gazeY! !

!GazePlayer methodsFor: 'as yet unclassified' stamp: 'sgb 9/21/2015 16:12'!
getGazeX
^ self sendMessageToCostume: #gazeX! !

!GazePlayer methodsFor: 'as yet unclassified' stamp: 'sgb 9/21/2015 16:12'!
getGazeY
^ self sendMessageToCostume: #gazeY! !

Morph subclass: #EyeMorph
	instanceVariableNames: 'eye'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeTracker-Etoys'!

!EyeMorph class methodsFor: 'as yet unclassified' stamp: 'sgb 9/21/2015 17:29'!
additionsToViewerCategories

^ #(

(#'positions' (

#(slot eyePositionX  'Shows the x of the eye position' Number readOnly Player getEyePositionX Player unused )
#(slot eyePositionY  'Shows the y of the eye position' Number readOnly Player getEyePositionY Player unused )
#(slot eyePositionZ  'Shows the z of the eye position' Number readOnly Player getEyePositionZ Player unused )

#(slot normalizedEyePositionX  'Shows the normalized x of the eye position' Number readOnly Player getNormalizedEyePositionX Player unused )
#(slot normalizedEyePositionY  'Shows the normalized y of the eye position' Number readOnly Player getNormalizedEyePositionY Player unused )
#(slot normalizedEyePositionZ  'Shows the normalized z of the eye position' Number readOnly Player getNormalizedEyePositionZ Player unused )

))

)! !

!EyeMorph methodsFor: 'viewer category filter' stamp: 'sgb 9/1/2015 17:23'!
categoriesForViewer
	^self validCategories , #(scripting)! !

!EyeMorph methodsFor: 'updating ui' stamp: 'sgb 9/1/2015 17:30'!
drawOn: aCanvas
	aCanvas fillOval: bounds color: self color! !

!EyeMorph methodsFor: 'accesing' stamp: 'sgb 9/1/2015 17:33'!
eye
	^ eye! !

!EyeMorph methodsFor: 'accesing' stamp: 'sgb 9/24/2015 17:20'!
eyeNormalizedPositionX
	^eye first ! !

!EyeMorph methodsFor: 'accesing' stamp: 'sgb 9/24/2015 17:20'!
eyeNormalizedPositionY
		^eye second! !

!EyeMorph methodsFor: 'accesing' stamp: 'sgb 9/24/2015 17:21'!
eyeNormalizedPositionZ
	^eye third 
	! !

!EyeMorph methodsFor: 'accesing' stamp: 'sgb 9/24/2015 17:19'!
eyePositionX
^eye fourth
	! !

!EyeMorph methodsFor: 'accesing' stamp: 'sgb 9/24/2015 17:20'!
eyePositionY
	^eye fifth
	! !

!EyeMorph methodsFor: 'accesing' stamp: 'sgb 9/24/2015 17:20'!
eyePositionZ
	^eye sixth ! !

!EyeMorph methodsFor: 'initializing' stamp: 'sgb 9/24/2015 17:18'!
initialize
	super initialize.
	self setInitialConfiguration.
	eye:= Array new: 6 withAll: 0.! !

!EyeMorph methodsFor: 'accesing' stamp: 'sgb 9/1/2015 17:34'!
newPlayerInstance
	^ EyePlayer newUserInstance! !

!EyeMorph methodsFor: 'accesing' stamp: 'sgb 10/13/2015 14:51'!
setInitialConfiguration
	self color: Color lightBlue;
		extent: 50@50;
		show! !

!EyeMorph methodsFor: 'accesing' stamp: 'sgb 9/21/2015 17:22'!
setInitialPosition
	self position: owner position + (90@117).! !

!EyeMorph methodsFor: 'updating' stamp: 'sgb 9/24/2015 16:30'!
updateData: data
	eye := data! !

!EyeMorph methodsFor: 'updating' stamp: 'sgb 11/2/2015 16:29'!
updateX: x y: y z: z 

	z=0 ifFalse:[

	| x1 y1 distanceToCenter |
	x1 := self owner left +(self owner width * x).
	distanceToCenter:= (self owner center x - x1) abs.
	(x1>=self owner center x) ifTrue: [x1:=self owner center x - distanceToCenter] ifFalse: [x1:=self owner center x + distanceToCenter] .

	y1 := self owner top + (self owner height * y).
	self center: x1 @ y1.  
	self color: Color lightBlue.]
		 ifTrue:[ self color: Color lightRed.]
	
	

! !

!EyeMorph methodsFor: 'viewer category filter' stamp: 'sgb 9/1/2015 17:23'!
validCategories
^(self class additionsToViewerCategories collect: [:each| each first])! !

Morph subclass: #EyeTrackerMorph
	instanceVariableNames: 'eyeTracker eyes isStepping startBtn stopBtn gaze'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeTracker-Etoys'!

!EyeTrackerMorph class methodsFor: 'as yet unclassified' stamp: 'sgb 9/24/2015 18:32'!
additionsToViewerCategories

^ #(

(#'eyetracker connection' (

#(command connect 'Connects this device' )
#(command disconnect 'Disconnects this device' )
#(slot isConnected 'Shows if the device is connected' Boolean readOnly Player getIsConnected Player unused )
#(slot connectionState 'Shows the state of the connection with the EyeTracker' String readOnly Player getConnectionState Player unused )

))

(#'screen and display' (


#(slot displaySizeWidth 'Shows the width of the display' Number readOnly Player getDisplaySizeWidth Player unused )
#(slot displaySizeHeight 'Shows the height of the display' Number readOnly Player getDisplaySizeHeight Player unused )
#(slot screenBoundsWidth 'Shows the width of the screen bounds' Number readOnly Player getScreenBoundsWidth Player unused )
#(slot screenBoundsHeight 'Shows the height of the screen bounds' Number readOnly Player getScreenBoundsHeight Player unused )

))

)! !

!EyeTrackerMorph class methodsFor: 'parts bin' stamp: 'sgb 11/18/2015 17:05'!
descriptionForPartsBin
	"Answer a description for use in parts bins"
	^ self
		partName: 'EyeX Tracker' translatedNoop
		categories: (Project current isPEProject
						ifTrue: [{'Physical Etoys' translatedNoop}]
						ifFalse: [#()])
		documentation: 'An object that lets you communicate with a Tobii EyeX tracker' translatedNoop! !

!EyeTrackerMorph methodsFor: 'buttons' stamp: 'sgb 9/1/2015 15:25'!
addButtons
	startBtn := (SimpleButtonMorph new label: ' Start ';
			position: self topLeft + 10;
			color: (Color green mixed: 0.3 with: Color blue muchLighter);
			borderColor: #raised;
			cornerStyle: #rounded;
			borderWidth: 2;
			actionSelector: #start;
			target: self).
	stopBtn := (SimpleButtonMorph new label: ' Stop ';
			position: startBtn bottomLeft + (0@10);
			color: (Color red mixed: 0.3 with: Color blue muchLighter);
			borderColor: #raised;
			cornerStyle: #rounded;
			borderWidth: 2;
			actionSelector: #stop;
			target: self).
			self addMorph: startBtn;
			addMorph: stopBtn.! !

!EyeTrackerMorph methodsFor: 'initializing' stamp: 'sgb 9/1/2015 15:19'!
addEyesToMyself
	eyes do: [:h | self addMorph: h].! !

!EyeTrackerMorph methodsFor: 'initializing' stamp: 'sgb 9/21/2015 16:19'!
addGazeToMyself
	gaze do: [:h | self addMorph: h].! !

!EyeTrackerMorph methodsFor: 'viewer category filter' stamp: 'sgb 9/1/2015 15:23'!
categoriesForViewer
	^self validCategories , #(scripting)! !

!EyeTrackerMorph methodsFor: 'accesing' stamp: 'sgb 9/1/2015 15:30'!
connect
	eyeTracker connect.
	self startStepping.
! !

!EyeTrackerMorph methodsFor: 'accesing' stamp: 'sgb 11/9/2015 16:30'!
connectionState
| connState anArray|
connState:=eyeTracker giveMeTheData connectionState.

(connState=0) ifFalse:[
anArray := #('Connected' 'FailToInitStream' 'WaitingForGazeData' 'Disconnected' 'TryingToConnect' 'SVersionTooLow' 'SVersionTooHigh').
^ anArray at: connState.
] ifTrue: [^ 'NotInitialized'.]



! !

!EyeTrackerMorph methodsFor: 'initializing' stamp: 'sgb 9/1/2015 15:19'!
createEyes
	eyes := (1 to: 2) collect: [:ign | EyeMorph new].! !

!EyeTrackerMorph methodsFor: 'initializing' stamp: 'sgb 9/21/2015 16:25'!
createGaze
		gaze := (1 to: 1) collect: [:ign | GazeMorph new].! !

!EyeTrackerMorph methodsFor: 'halo' stamp: 'sgb 9/1/2015 15:24'!
defersHaloToInteriorMorph: aMorph
	"It only defers halo to interior if the morph is one of the hands."
	^ eyes anySatisfy: [:es | es = aMorph]! !

!EyeTrackerMorph methodsFor: 'accesing' stamp: 'sgb 9/1/2015 15:31'!
disconnect
	self stopStepping.
	eyeTracker disconnect.! !

!EyeTrackerMorph methodsFor: 'accesing' stamp: 'sgb 9/1/2015 15:34'!
displaySizeHeight
^ eyeTracker giveMeTheData displaySizeHeight! !

!EyeTrackerMorph methodsFor: 'accesing' stamp: 'sgb 9/1/2015 15:34'!
displaySizeWidth
^ eyeTracker giveMeTheData displaySizeWidth! !

!EyeTrackerMorph methodsFor: 'initializing' stamp: 'sgb 9/21/2015 16:23'!
initialize
	super initialize.
	self stopStepping.
	self color: Color white;
		clipSubmorphs: true;
		extent: 500 @ 400.
	
	eyeTracker := EyeTracker  new.
	
	self initializeEyes.
	self initializeGaze.
	self addButtons.
 	self borderWidth: 2;
		  borderColor: Color red.

	! !

!EyeTrackerMorph methodsFor: 'initializing' stamp: 'sgb 9/1/2015 15:18'!
initializeEyes
	self createEyes;
		addEyesToMyself;
		nameEyes;
		positionEyes
! !

!EyeTrackerMorph methodsFor: 'initializing' stamp: 'sgb 9/21/2015 16:23'!
initializeGaze
	self createGaze;
		addGazeToMyself;
		nameGaze;
		positionGaze
! !

!EyeTrackerMorph methodsFor: 'accesing' stamp: 'sgb 9/1/2015 15:31'!
isConnected 
	^ eyeTracker  isConnected ! !

!EyeTrackerMorph methodsFor: 'initializing' stamp: 'sgb 10/13/2015 14:35'!
nameEyes
	eyes first setNameTo: 'Left Eye'.
	eyes second setNameTo: 'Right Eye'
	! !

!EyeTrackerMorph methodsFor: 'initializing' stamp: 'sgb 10/13/2015 14:35'!
nameGaze
	gaze first setNameTo: 'Gaze'
! !

!EyeTrackerMorph methodsFor: 'accesing' stamp: 'sgb 9/1/2015 15:31'!
newPlayerInstance
	^ EyeTrackerPlayer newUserInstance! !

!EyeTrackerMorph methodsFor: 'initializing' stamp: 'sgb 9/1/2015 15:21'!
positionEyes
	eyes with: {100@160. 350@160}
		do: [:m :p | m 
			setInitialConfiguration;
			center: self topLeft + p].! !

!EyeTrackerMorph methodsFor: 'initializing' stamp: 'sgb 9/21/2015 16:27'!
positionGaze
	gaze with: {100@160}
		do: [:m :p | m 
			setInitialConfiguration;
			center: self topLeft + p].! !

!EyeTrackerMorph methodsFor: 'fileIn/Out' stamp: 'sgb 9/1/2015 15:24'!
prepareToBeSaved
	super prepareToBeSaved.
	self stop! !

!EyeTrackerMorph methodsFor: 'accesing' stamp: 'sgb 9/1/2015 15:34'!
screenBoundsHeight
^ eyeTracker giveMeTheData screenBoundsHeight! !

!EyeTrackerMorph methodsFor: 'accesing' stamp: 'sgb 9/1/2015 15:34'!
screenBoundsWidth
^ eyeTracker giveMeTheData screenBoundsWidth! !

!EyeTrackerMorph methodsFor: 'buttons' stamp: 'sgb 9/1/2015 15:26'!
start 
	self connect.
	self borderColor: Color green.! !

!EyeTrackerMorph methodsFor: 'stepping' stamp: 'sgb 11/9/2015 16:06'!
step
	| data |
	
	eyeTracker isConnected ifTrue:[
	 
	Transcript show: self extent; cr.	
	data := eyeTracker giveMeTheData.


	eyes first 
		updateX: data leftNormalizedEyePositionX
		y: data leftNormalizedEyePositionY
		z: data leftNormalizedEyePositionZ.

	eyes first updateData: {
		data leftNormalizedEyePositionX.
		data leftNormalizedEyePositionY.
		data leftNormalizedEyePositionZ.
		data leftEyePositionX.
		data leftEyePositionY.
		data leftEyePositionZ.
	}.
		
	eyes second
		updateX: data rightNormalizedEyePositionX
		y: data rightNormalizedEyePositionY
		z: data rightNormalizedEyePositionZ.
	eyes second updateData: {
		data rightNormalizedEyePositionX.
		data rightNormalizedEyePositionY.
		data rightNormalizedEyePositionZ.
		data rightEyePositionX.
		data rightEyePositionY.
		data rightEyePositionZ.
	}.
data screenBoundsWidth = 0 ifTrue: [^ self].
		gaze first
				updateX: data gazeX / data screenBoundsWidth 
				y: data gazeY / data screenBoundsHeight
				z:0.
		gaze first updateData: {
				data gazeX.
				data gazeY.
	}.
].
	! !

!EyeTrackerMorph methodsFor: 'stepping' stamp: 'sgb 9/1/2015 15:28'!
stepTime
	^ 100! !

!EyeTrackerMorph methodsFor: 'buttons' stamp: 'sgb 9/1/2015 15:26'!
stop
	self disconnect.
	self borderColor: Color red;
		positionEyes

	"eyes first center: self topLeft + (100@100).
	eyes second center: self topLeft + (200 @ 100)"
! !

!EyeTrackerMorph methodsFor: 'viewer category filter' stamp: 'sgb 9/1/2015 15:23'!
validCategories
^(self class additionsToViewerCategories collect: [:each| each first])! !

Morph subclass: #GazeMorph
	instanceVariableNames: 'gaze'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeTracker-Etoys'!

GazeMorph class
	instanceVariableNames: 'gaze'!

GazeMorph class
	instanceVariableNames: 'gaze'!

!GazeMorph class methodsFor: 'as yet unclassified' stamp: 'sgb 9/21/2015 17:16'!
additionsToViewerCategories

^ #(

(#'positions' (

#(slot gazeX  'Shows the x of the gaze position' Number readOnly Player getGazeX Player unused )
#(slot gazeY  'Shows the y of the gaze position' Number readOnly Player getGazeY Player unused )



))

)! !

!GazeMorph methodsFor: 'viewer category filter' stamp: 'sgb 9/21/2015 16:13'!
categoriesForViewer
	^self validCategories , #(scripting)! !

!GazeMorph methodsFor: 'updating ui' stamp: 'sgb 9/21/2015 16:08'!
drawOn: aCanvas
	aCanvas fillOval: bounds color: self color! !

!GazeMorph methodsFor: 'accessing' stamp: 'sgb 9/21/2015 16:06'!
gaze
	^gaze! !

!GazeMorph methodsFor: 'accessing' stamp: 'sgb 9/24/2015 17:31'!
gazeX
	^gaze first! !

!GazeMorph methodsFor: 'accessing' stamp: 'sgb 9/24/2015 17:31'!
gazeY
	^gaze second! !

!GazeMorph methodsFor: 'initializing' stamp: 'sgb 9/24/2015 17:35'!
initialize
	super initialize.
	self setInitialConfiguration.
	gaze:= Array new: 2 withAll: 0.! !

!GazeMorph methodsFor: 'accessing' stamp: 'sgb 9/21/2015 16:07'!
newPlayerInstance
	^ GazePlayer newUserInstance! !

!GazeMorph methodsFor: 'accessing' stamp: 'sgb 9/21/2015 17:20'!
setInitialConfiguration
	self color: Color orange;
		extent: 30@30;
		show! !

!GazeMorph methodsFor: 'accessing' stamp: 'sgb 9/21/2015 17:26'!
setInitialPosition
	self position: owner position + (90@117).! !

!GazeMorph methodsFor: 'updating ui' stamp: 'sgb 9/24/2015 17:34'!
updateData: data
	gaze := data! !

!GazeMorph methodsFor: 'updating' stamp: 'sgb 9/21/2015 16:49'!
updateX: x y: y z: z 

	| x1 y1 |
	x1 := self owner left + (self owner width * x).
	y1 := self owner top + (self owner height * y).
	self center: x1 @ y1. 

! !

!GazeMorph methodsFor: 'viewer category filter' stamp: 'sgb 9/21/2015 16:03'!
validCategories
^(self class additionsToViewerCategories collect: [:each| each first])! !

Object subclass: #EyeTracker
	instanceVariableNames: 'isConnected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeTracker-Core'!

!EyeTracker methodsFor: 'connection' stamp: 'sgb 8/31/2015 16:07'!
connect
	self isConnected ifTrue: [^ self].
	EyeTrackerApi apiInitEyeTracker.
	isConnected:=true.
	
! !

!EyeTracker methodsFor: 'connection' stamp: 'sgb 8/31/2015 16:08'!
disconnect
self isConnected ifFalse: [^ self].
isConnected:=false.! !

!EyeTracker methodsFor: 'data adquisition' stamp: 'sgb 8/31/2015 16:11'!
giveMeTheData
 	^ self isConnected
		ifTrue: [EyeTrackerApi apiGiveMeTheData]
		ifFalse: [EyeXData nil]! !

!EyeTracker methodsFor: 'initialization' stamp: 'sgb 8/31/2015 16:08'!
initialize 
	isConnected :=false.

! !

!EyeTracker methodsFor: 'connection' stamp: 'sgb 8/31/2015 16:08'!
isConnected
	^ isConnected 

! !

Object subclass: #EyeTrackerApi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeTracker-FFI'!

!EyeTrackerApi class methodsFor: 'primitives' stamp: 'sgb 8/31/2015 14:58'!
apiDisconnectEyeTracker
	<apicall: long 'disconnectEyeTracker' () module: 'EyeTracker.dll'>
	^ self externalCallFailed! !

!EyeTrackerApi class methodsFor: 'primitives' stamp: ''!
apiFoo
	<apicall: long 'foo' () module: 'EyeTracker.dll'>
	^ self externalCallFailed! !

!EyeTrackerApi class methodsFor: 'primitives' stamp: 'sgb 8/31/2015 15:08'!
apiGiveMeTheData
	<apicall: EyeXData 'giveMeTheData' () module: 'EyeTracker.dll'>
	^ self externalCallFailed! !

!EyeTrackerApi class methodsFor: 'primitives' stamp: 'sgb 8/31/2015 14:56'!
apiInitEyeTracker
	<apicall: long 'initEyeTracker' () module: 'EyeTracker.dll'>
	^ self externalCallFailed! !

ExternalStructure subclass: #EyeXData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EyeTracker-FFI'!

EyeXData class
	instanceVariableNames: 'nilInstance'!

EyeXData class
	instanceVariableNames: 'nilInstance'!

!EyeXData class methodsFor: 'as yet unclassified' stamp: 'sgb 8/31/2015 17:49'!
fields

"
	self defineFields.
"
	^ #(
	(gazeX 'double')
	(gazeY 'double')

	(leftEyePositionX 'double')
	(leftNormalizedEyePositionX 'double')
	(leftEyePositionY 'double')
	(leftNormalizedEyePositionY 'double')
	(leftEyePositionZ 'double')
	(leftNormalizedEyePositionZ 'double')

	(rightEyePositionX 'double')
	(rightNormalizedEyePositionX 'double')
	(rightEyePositionY 'double')
	(rightNormalizedEyePositionY 'double')
	(rightEyePositionZ 'double')
	(rightNormalizedEyePositionZ 'double')

	(gazeTimeStamp 'double')

	(displaySizeWidth 'double')
	(displaySizeHeight 'double')
	(screenBoundsWidth 'double')
	(screenBoundsHeight 'double')

	"This long has padding"
	(connectionState 'long')

	)
        






! !

!EyeXData class methodsFor: 'as yet unclassified' stamp: 'sgb 8/31/2015 15:11'!
nil
	^ nilInstance ifNil: [nilInstance := self new]! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
connectionState
	"This method was automatically generated"
	^handle signedLongAt: 153! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:41'!
connectionState2
	"This method was automatically generated"
	^handle signedLongAt: 117! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:41'!
connectionState2: anObject
	"This method was automatically generated"
	handle signedLongAt: 117 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
connectionState: anObject
	"This method was automatically generated"
	handle signedLongAt: 153 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
displaySizeHeight
	"This method was automatically generated"
	^handle doubleAt: 129! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
displaySizeHeight: anObject
	"This method was automatically generated"
	handle doubleAt: 129 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
displaySizeWidth
	"This method was automatically generated"
	^handle doubleAt: 121! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
displaySizeWidth: anObject
	"This method was automatically generated"
	handle doubleAt: 121 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
gazeTimeStamp
	"This method was automatically generated"
	^handle doubleAt: 113! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
gazeTimeStamp: anObject
	"This method was automatically generated"
	handle doubleAt: 113 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
gazeX
	"This method was automatically generated"
	^handle doubleAt: 1! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
gazeX: anObject
	"This method was automatically generated"
	handle doubleAt: 1 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
gazeY
	"This method was automatically generated"
	^handle doubleAt: 9! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
gazeY: anObject
	"This method was automatically generated"
	handle doubleAt: 9 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
leftEyePositionX
	"This method was automatically generated"
	^handle doubleAt: 17! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
leftEyePositionX: anObject
	"This method was automatically generated"
	handle doubleAt: 17 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
leftEyePositionY
	"This method was automatically generated"
	^handle doubleAt: 33! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
leftEyePositionY: anObject
	"This method was automatically generated"
	handle doubleAt: 33 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
leftEyePositionZ
	"This method was automatically generated"
	^handle doubleAt: 49! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
leftEyePositionZ: anObject
	"This method was automatically generated"
	handle doubleAt: 49 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
leftNormalizedEyePositionX
	"This method was automatically generated"
	^handle doubleAt: 25! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
leftNormalizedEyePositionX: anObject
	"This method was automatically generated"
	handle doubleAt: 25 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
leftNormalizedEyePositionY
	"This method was automatically generated"
	^handle doubleAt: 41! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
leftNormalizedEyePositionY: anObject
	"This method was automatically generated"
	handle doubleAt: 41 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
leftNormalizedEyePositionZ
	"This method was automatically generated"
	^handle doubleAt: 57! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
leftNormalizedEyePositionZ: anObject
	"This method was automatically generated"
	handle doubleAt: 57 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
rightEyePositionX
	"This method was automatically generated"
	^handle doubleAt: 65! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
rightEyePositionX: anObject
	"This method was automatically generated"
	handle doubleAt: 65 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
rightEyePositionY
	"This method was automatically generated"
	^handle doubleAt: 81! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
rightEyePositionY: anObject
	"This method was automatically generated"
	handle doubleAt: 81 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
rightEyePositionZ
	"This method was automatically generated"
	^handle doubleAt: 97! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
rightEyePositionZ: anObject
	"This method was automatically generated"
	handle doubleAt: 97 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
rightNormalizedEyePositionX
	"This method was automatically generated"
	^handle doubleAt: 73! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
rightNormalizedEyePositionX: anObject
	"This method was automatically generated"
	handle doubleAt: 73 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
rightNormalizedEyePositionY
	"This method was automatically generated"
	^handle doubleAt: 89! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
rightNormalizedEyePositionY: anObject
	"This method was automatically generated"
	handle doubleAt: 89 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
rightNormalizedEyePositionZ
	"This method was automatically generated"
	^handle doubleAt: 105! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
rightNormalizedEyePositionZ: anObject
	"This method was automatically generated"
	handle doubleAt: 105 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
screenBoundsHeight
	"This method was automatically generated"
	^handle doubleAt: 145! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
screenBoundsHeight: anObject
	"This method was automatically generated"
	handle doubleAt: 145 put: anObject! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
screenBoundsWidth
	"This method was automatically generated"
	^handle doubleAt: 137! !

!EyeXData methodsFor: 'accessing' stamp: 'sgb 8/31/2015 17:44'!
screenBoundsWidth: anObject
	"This method was automatically generated"
	handle doubleAt: 137 put: anObject! !
